
'ICQstatus v1.0
'
'ICQ status indicator script for Samurize version 1.25 and later
'
'
'This script grabs the ICQ status indicator of ICQ users from the web. ICQ status indicators are coming in 10 designs. The first parameter is the users ICQ number, the second is the designs number.
'The active script meters type should be Image!
'Most designs are already useable with Samurize, the ones changing they size with the users status aren't recommended for use. 
'
'Type	Size(pixel):
'1	varying
'2	80x21
'3	224x17
'4	141x23
'5	18x18
'6	98x34
'7	varying
'8	197x15
'9	55x14
'10	varying
'
'(You can check them all at http://www.icq.com/features/web/indicator.html )
'
' This script was made using the FetchImage script made by ViX. All credits go to him (except the ones for the idea :)).
'
'Contact me with your problems! (Use the forums please!)
'
'QuippeR


DIRECTORY = "ICQimages"	'The script creates a directory with this name in your Samurize dir. This will contain the images.



' Don't change the code below this line!
'-----------------------------------------

Function ICQstatus(ICQnumber, ImageType)
On Error Resume Next


    Dim fso
    Set fso = CreateObject("Scripting.FileSystemObject")


' Path to Samurize folder
    Dim SamurizeDir
    SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")

' Path to TEMP folder
    Dim imagespath
    imagespath = SamurizeDir & DIRECTORY & "\"
    If Not fso.FolderExists(imagespath) Then
        fso.CreateFolder (imagespath)
    End If

	IMGTemp = imagespath & ICQnumber & ".gif"

' Delete old files --> Frees some space
    Dim f1, fc, f
    Set f = fso.GetFolder(imagespath)
    Set fc = f.Files
    For Each f1 In fc
	if f1 = IMGTemp then
            fso.DeleteFile (f1)
	end if
    Next
    Set f1 = Nothing
    Set fc = Nothing


	IMGTemp = imagespath & ICQnumber & ".gif"

' The job
    Dim myCommand
    Dim OK
	IMGsource = "http://web.icq.com/whitepages/online?icq=" & ICQnumber & "&img=" & ImageType
        OK = ReturnHTML(IMGsource, IMGTemp)
		ICQstatus = IMGTemp
		Set fso = Nothing


End Function


Private Function ReturnHTML(sURL, IMGTemp)
On Error Resume Next
    Dim objXMLHTTP
    Dim OK, strHTML
    Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")
    On Error Resume Next
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    If Err = 0 Then
        strHTML = objXMLHTTP.responseBody
        strHTML = SimpleBinaryToString(strHTML)
        If strHTML <> False Then
            OK = Tallenna(IMGTemp, strHTML)
        Else
            OK = strHTML
        End If
        ReturnHTML = OK
    Else
        ReturnHTML = False
    End If
    On Error GoTo 0
    Set objXMLHTTP = Nothing
End Function

Private Function SimpleBinaryToString(Binary)
    'SimpleBinaryToString converts binary data (VT_UI1 | VT_ARRAY Or MultiByte string)
    'to a string (BSTR) using MultiByte VBS functions
    Dim I, Found
    Dim S
    For I = 1 To LenB(Binary)
        S = S & Chr(AscB(MidB(Binary, I, 1)))
    Next
    ' Check if fetch returns a html page or an image
    Found = InStr(1, S, "<html>")
    If Found = 0 Then Found = InStr(1, S, "<HTML>")
    If Found = 0 Then   ' Didn't find
        SimpleBinaryToString = S
    Else                ' HTML
        SimpleBinaryToString = False
    End If
End Function

Private Function Tallenna(TIEDOSTONIMI, TEXTI)
    Dim fso, f
    Tallenna = False
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set f = fso.CreateTextFile(TIEDOSTONIMI, True)
    f.Write (TEXTI)
    f.Close
    Set f = Nothing
    Set fso = Nothing
    Tallenna = True
End Function
